package me.lensfrex.manager.data;

import java.io.Serializable;
import java.util.Comparator;
import java.util.Map;

public class Student implements Serializable {
    private String name;
    //private String id;
    // 改用long是因为方便排序 ：）
    private long id;
    private Map<String, Integer> score;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Map<String, Integer> getScore() {
        return score;
    }

    public void setScore(Map<String, Integer> score) {
        this.score = score;
    }

    public Student(long id, String name, Map<String, Integer> score) {
        this.id = id;
        this.name = name;
        this.score = score;
    }

    public int getGeneralScore() {
        int generalScore = 0;
        for (int score : getScore().values()) {
            generalScore += score;
        }

        return generalScore;
    }

    public static Comparator<Student> compareByName = (s1, s2) -> s1.getName().compareTo(s2.getName());
    public static Comparator<Student> compareById = (s1, s2) -> (int) (s1.id - s2.id);
    public static Comparator<Student> compareByGeneralScore = (s1, s2) -> s1.getGeneralScore() - s2.getGeneralScore();
}
